"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContributionRewardProposal = void 0;
var bn_js_1 = __importDefault(require("bn.js"));
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var ContributionRewardProposal = /** @class */ (function (_super) {
    __extends(ContributionRewardProposal, _super);
    function ContributionRewardProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ContributionRewardProposal, "fragment", {
        get: function () {
            if (!this.fragmentField) {
                this.fragmentField = {
                    name: 'ContributionRewardProposalFields',
                    fragment: graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          fragment ContributionRewardProposalFields on Proposal {\n            contributionReward {\n              id\n              beneficiary\n              ethReward\n              ethRewardLeft\n              externalToken\n              externalTokenReward\n              externalTokenRewardLeft\n              nativeTokenReward\n              nativeTokenRewardLeft\n              periods\n              periodLength\n              reputationReward\n              reputationChangeLeft\n              alreadyRedeemedReputationPeriods\n              alreadyRedeemedExternalTokenPeriods\n              alreadyRedeemedNativeTokenPeriods\n              alreadyRedeemedEthPeriods\n            }\n          }\n        "], ["\n          fragment ContributionRewardProposalFields on Proposal {\n            contributionReward {\n              id\n              beneficiary\n              ethReward\n              ethRewardLeft\n              externalToken\n              externalTokenReward\n              externalTokenRewardLeft\n              nativeTokenReward\n              nativeTokenRewardLeft\n              periods\n              periodLength\n              reputationReward\n              reputationChangeLeft\n              alreadyRedeemedReputationPeriods\n              alreadyRedeemedExternalTokenPeriods\n              alreadyRedeemedNativeTokenPeriods\n              alreadyRedeemedEthPeriods\n            }\n          }\n        "])))
                };
            }
            return this.fragmentField;
        },
        enumerable: false,
        configurable: true
    });
    ContributionRewardProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("ContributionRewardProposal ItemMap failed. " + (queriedId ? "Could not find ContributionRewardProposal with id '" + queriedId + "'" : ''));
            return null;
        }
        var ethRewardLeft = (item.contributionReward.ethRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.ethRewardLeft)) ||
            null;
        var externalTokenRewardLeft = (item.contributionReward.externalTokenRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.externalTokenRewardLeft)) ||
            null;
        var nativeTokenRewardLeft = (item.contributionReward.nativeTokenRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.nativeTokenRewardLeft)) ||
            null;
        var reputationChangeLeft = (item.contributionReward.reputationChangeLeft !== null &&
            new bn_js_1.default(item.contributionReward.reputationChangeLeft)) ||
            null;
        var contributionRewardState = index_1.ContributionRewardPlugin.itemMap(context, item.scheme, queriedId);
        if (!contributionRewardState) {
            return null;
        }
        var contributionReward = new index_1.ContributionRewardPlugin(context, contributionRewardState);
        var contributionRewardProposal = new ContributionRewardProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, contributionReward, contributionRewardProposal, 'ContributionReward');
        if (baseState == null) {
            return null;
        }
        return __assign(__assign({}, baseState), { alreadyRedeemedEthPeriods: Number(item.contributionReward.alreadyRedeemedEthPeriods), alreadyRedeemedExternalTokenPeriods: Number(item.contributionReward.alreadyRedeemedExternalTokenPeriods), alreadyRedeemedNativeTokenPeriods: Number(item.contributionReward.alreadyRedeemedNativeTokenPeriods), alreadyRedeemedReputationPeriods: Number(item.contributionReward.alreadyRedeemedReputationPeriods), beneficiary: item.contributionReward.beneficiary, ethReward: new bn_js_1.default(item.contributionReward.ethReward), ethRewardLeft: ethRewardLeft, externalToken: item.contributionReward.externalToken, externalTokenReward: new bn_js_1.default(item.contributionReward.externalTokenReward), externalTokenRewardLeft: externalTokenRewardLeft, nativeTokenReward: new bn_js_1.default(item.contributionReward.nativeTokenReward), nativeTokenRewardLeft: nativeTokenRewardLeft, periodLength: Number(item.contributionReward.periodLength), periods: Number(item.contributionReward.periods), reputationChangeLeft: reputationChangeLeft, reputationReward: new bn_js_1.default(item.contributionReward.reputationReward) });
    };
    ContributionRewardProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        var result = this.context.getObservableObject(this.context, query, ContributionRewardProposal.itemMap, this.id, apolloQueryOptions);
        return result;
    };
    return ContributionRewardProposal;
}(index_1.Proposal));
exports.ContributionRewardProposal = ContributionRewardProposal;
var templateObject_1, templateObject_2;
//# sourceMappingURL=proposal.js.map