"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContributionRewardExtProposal = void 0;
var bn_js_1 = __importDefault(require("bn.js"));
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var ContributionRewardExtProposal = /** @class */ (function (_super) {
    __extends(ContributionRewardExtProposal, _super);
    function ContributionRewardExtProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContributionRewardExtProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("ContributionRewardProposal ItemMap failed.\n          " + (queriedId ? "Could not find ContributionRewardProposal with id '" + queriedId + "'" : ''));
            return null;
        }
        var ethRewardLeft = (item.contributionReward.ethRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.ethRewardLeft)) ||
            null;
        var externalTokenRewardLeft = (item.contributionReward.externalTokenRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.externalTokenRewardLeft)) ||
            null;
        var nativeTokenRewardLeft = (item.contributionReward.nativeTokenRewardLeft !== null &&
            new bn_js_1.default(item.contributionReward.nativeTokenRewardLeft)) ||
            null;
        var reputationChangeLeft = (item.contributionReward.reputationChangeLeft !== null &&
            new bn_js_1.default(item.contributionReward.reputationChangeLeft)) ||
            null;
        var contributionRewardExtState = index_1.ContributionRewardExtPlugin.itemMap(context, item.scheme, queriedId);
        if (!contributionRewardExtState) {
            return null;
        }
        var contributionRewardExt = new index_1.ContributionRewardExtPlugin(context, contributionRewardExtState);
        var contributionRewardExtProposal = new ContributionRewardExtProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, contributionRewardExt, contributionRewardExtProposal, 'ContributionRewardExt');
        if (baseState == null) {
            return null;
        }
        return __assign(__assign({}, baseState), { alreadyRedeemedEthPeriods: Number(item.contributionReward.alreadyRedeemedEthPeriods), alreadyRedeemedExternalTokenPeriods: Number(item.contributionReward.alreadyRedeemedExternalTokenPeriods), alreadyRedeemedNativeTokenPeriods: Number(item.contributionReward.alreadyRedeemedNativeTokenPeriods), alreadyRedeemedReputationPeriods: Number(item.contributionReward.alreadyRedeemedReputationPeriods), beneficiary: item.contributionReward.beneficiary, ethReward: new bn_js_1.default(item.contributionReward.ethReward), ethRewardLeft: ethRewardLeft, externalToken: item.contributionReward.externalToken, externalTokenReward: new bn_js_1.default(item.contributionReward.externalTokenReward), externalTokenRewardLeft: externalTokenRewardLeft, nativeTokenReward: new bn_js_1.default(item.contributionReward.nativeTokenReward), nativeTokenRewardLeft: nativeTokenRewardLeft, periodLength: Number(item.contributionReward.periodLength), periods: Number(item.contributionReward.periods), reputationChangeLeft: reputationChangeLeft, reputationReward: new bn_js_1.default(item.contributionReward.reputationReward) });
    };
    ContributionRewardExtProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        var result = this.context.getObservableObject(this.context, query, ContributionRewardExtProposal.itemMap, this.id, apolloQueryOptions);
        return result;
    };
    return ContributionRewardExtProposal;
}(index_1.Proposal));
exports.ContributionRewardExtProposal = ContributionRewardExtProposal;
var templateObject_1;
//# sourceMappingURL=proposal.js.map