"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericPluginProposal = void 0;
var bn_js_1 = __importDefault(require("bn.js"));
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var GenericPluginProposal = /** @class */ (function (_super) {
    __extends(GenericPluginProposal, _super);
    function GenericPluginProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GenericPluginProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("GenericPluginProposal ItemMap failed. " + (queriedId ? "Could not find GenericPluginProposal with id '" + queriedId + "'" : ''));
            return null;
        }
        var genericSchemeState = index_1.GenericPlugin.itemMap(context, item.scheme, queriedId);
        if (!genericSchemeState) {
            return null;
        }
        var genericScheme = new index_1.GenericPlugin(context, genericSchemeState);
        var genericSchemeProposal = new GenericPluginProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, genericScheme, genericSchemeProposal, 'GenericScheme');
        if (!baseState) {
            return null;
        }
        return __assign(__assign({}, baseState), { callData: item.genericScheme.callData, contractToCall: item.genericScheme.contractToCall, executed: item.genericScheme.executed, returnValue: item.genericScheme.returnValue, value: new bn_js_1.default(item.genericScheme.value) });
    };
    GenericPluginProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        var result = this.context.getObservableObject(this.context, query, GenericPluginProposal.itemMap, this.id, apolloQueryOptions);
        return result;
    };
    GenericPluginProposal.fragment = {
        name: 'GenericPluginProposalFields',
        fragment: graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      fragment GenericPluginProposalFields on Proposal {\n        genericScheme {\n          id\n          contractToCall\n          callData\n          executed\n          returnValue\n          value\n        }\n      }\n    "], ["\n      fragment GenericPluginProposalFields on Proposal {\n        genericScheme {\n          id\n          contractToCall\n          callData\n          executed\n          returnValue\n          value\n        }\n      }\n    "])))
    };
    return GenericPluginProposal;
}(index_1.Proposal));
exports.GenericPluginProposal = GenericPluginProposal;
var templateObject_1, templateObject_2;
//# sourceMappingURL=proposal.js.map