"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluginManagerProposal = void 0;
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var PluginManagerProposal = /** @class */ (function (_super) {
    __extends(PluginManagerProposal, _super);
    function PluginManagerProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PluginManagerProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("PluginManagerProposal ItemMap failed.\n        " + (queriedId && "Could not find PluginManagerProposal with id '" + queriedId + "'"));
            return null;
        }
        var pluginManagerState = index_1.PluginManagerPlugin.itemMap(context, item.scheme, queriedId);
        if (!pluginManagerState) {
            return null;
        }
        var pluginManager = new index_1.PluginManagerPlugin(context, pluginManagerState);
        var pluginManagerProposal = new PluginManagerProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, pluginManager, pluginManagerProposal, 'SchemeFactory');
        if (!baseState) {
            return null;
        }
        return __assign(__assign({}, baseState), { pluginRegistered: item.schemeFactory.schemeRegistered, pluginRemoved: item.schemeFactory.schemeRemoved, pluginToRegisterData: item.schemeFactory.schemeToRegisterData, pluginToRegisterDecodedData: pluginManager.decodeDataByPluginName(item.schemeFactory.schemeToRegisterName, item.schemeFactory.schemeToRegisterData), pluginToRegisterName: item.schemeFactory.schemeToRegisterName, pluginToRegisterPackageVersion: item.schemeFactory.schemeToRegisterPackageVersion, pluginToRegisterPermission: item.schemeFactory.schemeToRegisterPermission, pluginToRemove: item.schemeFactory.schemeToRemove, decision: item.schemeFactory.decision, dao: {
                id: item.dao.id,
                entity: new index_1.DAO(context, item.dao.id)
            } });
    };
    PluginManagerProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        var result = this.context.getObservableObject(this.context, query, PluginManagerProposal.itemMap, this.id, apolloQueryOptions);
        return result;
    };
    PluginManagerProposal.fragment = {
        name: 'PluginManagerProposalFields',
        fragment: graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      fragment PluginManagerProposalFields on Proposal {\n        schemeFactory {\n          id\n          dao {\n            id\n            schemes {\n              id\n              address\n            }\n          }\n          schemeToRegisterName\n          schemeToRegisterData\n          schemeToRegisterPackageVersion\n          schemeToRegisterPermission\n          schemeToRemove\n          decision\n          schemeRegistered\n          schemeRemoved\n        }\n      }\n    "], ["\n      fragment PluginManagerProposalFields on Proposal {\n        schemeFactory {\n          id\n          dao {\n            id\n            schemes {\n              id\n              address\n            }\n          }\n          schemeToRegisterName\n          schemeToRegisterData\n          schemeToRegisterPackageVersion\n          schemeToRegisterPermission\n          schemeToRemove\n          decision\n          schemeRegistered\n          schemeRemoved\n        }\n      }\n    "])))
    };
    return PluginManagerProposal;
}(index_1.Proposal));
exports.PluginManagerProposal = PluginManagerProposal;
var templateObject_1, templateObject_2;
//# sourceMappingURL=proposal.js.map