import BN from 'bn.js';
import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { IEntityRef } from '../../entity';
import { Address, Arc, DAO, IApolloQueryOptions, IProposalState, Operation, Proposal } from '../../index';
export interface IJoinProposalState extends IProposalState {
    proposedMember: Address;
    dao: IEntityRef<DAO>;
    funding: BN;
    executed: boolean;
    reputationMinted: BN;
}
export declare class JoinProposal extends Proposal<IJoinProposalState> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query?: string): IJoinProposalState | null;
    private static fragmentField;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<IJoinProposalState>;
    /**
     * Redeem this proposal after it was accepted
     */
    redeem(): Operation<boolean>;
}
