import { Address, Arc, IGenesisProtocolParams, IInitParams, IPluginManagerProposalState, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionResultHandler } from '../../index';
export interface IPluginManagerState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
        daoFactory: Address;
    };
}
export declare type IProposalCreateOptionsPM = IProposalCreateOptions<'GenericScheme'> | IProposalCreateOptions<'ContributionReward'> | IProposalCreateOptions<'Competition'> | IProposalCreateOptions<'ContributionRewardExt'> | IProposalCreateOptions<'FundingRequest'> | IProposalCreateOptions<'Join'> | IProposalCreateOptions<'SchemeRegistrar'> | IProposalCreateOptions<'SchemeFactory'> | IProposalCreateOptions<'ReputationFromToken'> | IProposalCreateOptions<'TokenTrade'>;
export interface IProposalCreateOptions<TName extends keyof IInitParams> extends IProposalBaseCreateOptions {
    add?: {
        permissions: string;
        pluginName: TName;
        pluginInitParams: IInitParams[TName];
    };
    remove?: {
        plugin: string;
    };
}
export interface IInitParamsPM {
    daoId: string;
    votingMachine: string;
    votingParams: number[];
    voteOnBehalf: string;
    voteParamsHash: string;
    daoFactory: string;
}
export declare class PluginManagerPlugin extends ProposalPlugin<IPluginManagerState, IPluginManagerProposalState, IProposalCreateOptionsPM> {
    static fragment: {
        name: string;
        fragment: import("graphql").DocumentNode;
    };
    static initializeParamsMap(initParams: IInitParamsPM): (string | number[])[];
    static itemMap(context: Arc, item: any, queriedId?: string): IPluginManagerState | null;
    decodeDataByPluginName: (pluginName: string, encodedData: string) => any;
    createProposalTransaction(options: IProposalCreateOptionsPM): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
}
