import { Observable } from 'rxjs';
import { Arc, DAO, IApolloQueryOptions, IEntityRef, IProposalState, Proposal } from '../../index';
export interface IPluginManagerProposalState extends IProposalState {
    dao: IEntityRef<DAO>;
    pluginToRegisterName: string;
    pluginToRegisterData: string;
    pluginToRegisterDecodedData: any;
    pluginToRegisterPackageVersion: string[];
    pluginToRegisterPermission: string;
    pluginToRemove: string;
    decision: string;
    pluginRegistered: boolean;
    pluginRemoved: boolean;
}
export declare class PluginManagerProposal extends Proposal<IPluginManagerProposalState> {
    static fragment: {
        name: string;
        fragment: import("graphql").DocumentNode;
    };
    static itemMap(context: Arc, item: any, queriedId?: string): IPluginManagerProposalState | null;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<IPluginManagerProposalState>;
}
