import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { IEntityRef } from '../../entity';
import { Address, Arc, DAO, IApolloQueryOptions, IProposalState, Operation, Proposal } from '../../index';
export interface ITokenTradeProposalState extends IProposalState {
    dao: IEntityRef<DAO>;
    beneficiary: Address;
    sendTokenAddress: Address;
    sendTokenAmount: number;
    receiveTokenAddress: Address;
    receiveTokenAmount: number;
    executed: boolean;
    redeemed: boolean;
}
export declare class TokenTradeProposal extends Proposal<ITokenTradeProposalState> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query?: string): ITokenTradeProposalState | null;
    private static fragmentField;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<ITokenTradeProposalState>;
    /**
     * Redeem this proposal after it was accepted
     */
    redeem(): Operation<boolean>;
}
